import java.util.Random;
import javafx.scene.input.MouseEvent;
import prog1.graphics.ApplicationBase;
import prog1.graphics.Image;
import static prog1.graphics.Graphics.*;
import static prog1.functional.Functional.*;

// Windows:
// javac -cp .;prog1javalib.jar BarChart.java
// java -cp .;prog1javalib.jar BarChart

// OS X:
// javac -cp .:prog1javalib.jar BarChart.java
// java -cp .:prog1javalib.jar BarChart

public class BarChart extends javafx.application.Application {

	private final int[] data = new int[10];
	private int selected = -1;
	private String status = "status";
	
	public BarChart() {
		Random rnd = new Random();
		for (int i = 0; i < data.length; i++) {
			data[i] = rnd.nextInt(200);
		}
	}

	private Image barImage(int value, int index) {
		Image rect;
		if(index>selected){
			rect = rectangle(30, value, "gray");
		}else{
			rect = rectangle(30, value, "green");
		}
		rect.setOnMouseMoved(this::onMove, index);
		Image bar;
		bar = above(rectangle(30, 200-value, "transparent"), rect);
		bar = above(bar, text(Integer.toString(value), 15, "black"));
		Image bg = rectangle(50, 250, "transparent");
		bg.setOnMouseMoved(this::onMove, -1);
		bar = overlay(bar, bg);
		return bar;
	}
 
	private Image onDraw() {
		Image[] bars = map(data, this::barImage);
		Image chat = beside(bars, 0, data.length);
		int sum=0;
		for(int i=0;i<data.length;i++){
			if(i<=selected)sum+=data[i];
		}
		if(selected==-1)status = "";else status = "sum = "+sum;
		Image bottom = overlay(text(status, 20, "black"), rectangle(500, 50, "yellow"));
		chat = above(chat, bottom);
		return chat;
	}

	void onMove(MouseEvent event, Object target) {
		selected = (int)target;
	}
	
	@Override
	public void start(javafx.stage.Stage stage) {
		ApplicationBase.start("Bar Chart", 500, 300, stage, this::onDraw);
	}

}
